if select(2,UnitClass("player")) ~= "MONK" then return end

local addonName, MonkTimers = ...

local L = LibStub("AceLocale-3.0"):GetLocale(MonkTimers.XiTimersGUILocale, true)



XiTimers.options.args.powerbars = {
    type = "group",
    name = "powerbars",
    args = {
		chibar = {
			order = 1,
			type = "toggle",
			name = L["Chi Bar"],
			set = function(info,val)
						XiTimers.ActiveProfile.ChiBar = val
						XiTimers.ProcessSetting("ChiBar")
				  end,
			get = function(info) return XiTimers.ActiveProfile.ChiBar end,
		},
		ChiBarSize = {
            order = 2,
            type = "range",
            name = L["Scaling"],
            min = 0.5,
            max = 4,
            step = 0.05,
            bigStep = 0.1,
            set = function(info, val)
                        XiTimers.ActiveProfile.ChiBarSize = val  XiTimers.ProcessSetting("ChiBarSize")	
                  end,
            get = function(info) return XiTimers.ActiveProfile.ChiBarSize end,
        },
		ChiBarFontSize = {
            order = 3,
            type = "range",
            name = L["Font Size"],
            min = 5,
            max = 30,
            step = 1,
            set = function(info, val)
                        XiTimers.ActiveProfile.PowerBarFontSize = val  XiTimers.ProcessSetting("PowerBarFontSize")
                  end,
            get = function(info) return XiTimers.ActiveProfile.PowerBarFontSize end,
        },
		hstagger = {
		    order = 10,
            type = "header",
            name = L["Stagger Bar"],
		},
		staggerbar = {
			order = 11,
			type = "toggle",
			name = L["Stagger Bar"],
			set = function(info,val)
						XiTimers.ActiveProfile.StaggerBar = val
						XiTimers.ProcessSetting("StaggerBar")
				  end,
			get = function(info) return XiTimers.ActiveProfile.StaggerBar end,
		},
		StaggerBarSize = {
            order = 12,
            type = "range",
            name = L["Scaling"],
            min = 0.5,
            max = 4,
            step = 0.1,
            bigStep = 0.1,
            set = function(info, val)
                        XiTimers.ActiveProfile.StaggerSize = val  XiTimers.ProcessSetting("StaggerSize")	
                  end,
            get = function(info) return XiTimers.ActiveProfile.PowerBarSize end,
        },
		StaggerWidth = {
            order = 12,
            type = "range",
            name = L["Width"],
            min = 50,
            max = 200,
            step = 1,
            bigStep = 10,
            set = function(info, val)
                        XiTimers.ActiveProfile.StaggerWidth = val  XiTimers.ProcessSetting("StaggerWidth")	
						XiTimers.LoadProfile()
                  end,
            get = function(info) return XiTimers.ActiveProfile.StaggerWidth end,
        },
		StaggerFontSize = {
            order = 13,
            type = "range",
            name = L["Font Size"],
            min = 5,
            max = 30,
            step = 1,
            set = function(info, val)
                        XiTimers.ActiveProfile.StaggerFontSize = val  XiTimers.ProcessSetting("StaggerFontSize")
                  end,
            get = function(info) return XiTimers.ActiveProfile.PowerBarFontSize end,
        },
		hstaggertext = {
            order = 20,
			type = "header",
			name = "",
		},
		staggerdot = {
			order = 23,
			type = "toggle",
			name = L["Stagger Dot Tick"],
			set = function(info, val) XiTimers.ActiveProfile.StaggerDot = val end,
			get = function(info) return XiTimers.ActiveProfile.StaggerDot end,
		},
		staggerdottotal = {
			order = 24,
			type = "toggle",
			name = L["Stagger Dot Total"],
			set = function(info, val) XiTimers.ActiveProfile.StaggerDotTotal = val end,
			get = function(info) return XiTimers.ActiveProfile.StaggerDotTotal end,
		},
		staggerdotpercent = {
			order = 25,
			type = "toggle",
			name = L["Stagger Dot Percent"],
			set = function(info, val) XiTimers.ActiveProfile.StaggerDotPercent = val end,
			get = function(info) return XiTimers.ActiveProfile.StaggerDotPercent end,
		},
		h2 = {
            order = 30,
            type = "header",
            name = "",
        },
		PowerBarFont = {
			order = 41,
			type = "select",
			name = L["Font"] ,
			values = AceGUIWidgetLSMlists.font,
			set = function(info, val) XiTimers.ActiveProfile.PowerBarFont = val XiTimers.ProcessSetting("PowerBarFont") end,
			get = function(info) return XiTimers.ActiveProfile.PowerBarFont end,
			dialogControl = "LSM30_Font",
		},
		PowerBarTexture = {
			order = 42,
			type = "select",
			name = L["Texture"],
			values = AceGUIWidgetLSMlists.statusbar,
			set = function(info, val) XiTimers.ActiveProfile.PowerBarTexture = val XiTimers.ProcessSetting("PowerBarTexture") end,
			get = function(info) return XiTimers.ActiveProfile.PowerBarTexture end,
			dialogControl = "LSM30_Statusbar",
		},		

    },	
}


local ACD = LibStub("AceConfigDialog-3.0")
local frame = ACD:AddToBlizOptions(addonName, L["Power Bars"], addonName, "powerbars")
frame:SetScript("OnEvent", function(self) InterfaceOptionsFrame:Hide() end)
frame:HookScript("OnShow", function(self) if InCombatLockdown() then InterfaceOptionsFrame:Hide() end XiTimers.LastGUIPanel = self end)
frame:RegisterEvent("PLAYER_REGEN_DISABLED")

